--- res_config_ldap.c.1	2009-08-12 19:19:00.000000000 +0300
+++ res_config_ldap.c	2009-08-31 22:24:24.000000000 +0300
@@ -1195,13 +1195,22 @@
 	ldap_mods = ast_calloc(sizeof(LDAPMod *), mods_size);
 	ldap_mods[0] = ast_calloc(1, sizeof(LDAPMod));
 
-	ldap_mods[0]->mod_op = LDAP_MOD_REPLACE;
+	
+	
+//	ldap_mods[0]->mod_op = LDAP_MOD_REPLACE;
 	ldap_mods[0]->mod_type = ast_calloc(sizeof(char), strlen(newparam) + 1);
 	strcpy(ldap_mods[0]->mod_type, newparam);
 
-	ldap_mods[0]->mod_values = ast_calloc(sizeof(char), 2);
-	ldap_mods[0]->mod_values[0] = ast_calloc(sizeof(char), strlen(newval) + 1);
-	strcpy(ldap_mods[0]->mod_values[0], newval);
+	if (strlen(newval) == 0) {
+		ldap_mods[0]->mod_op = LDAP_MOD_DELETE;
+	} else {
+		ldap_mods[0]->mod_op = LDAP_MOD_REPLACE;
+
+		ldap_mods[0]->mod_values = ast_calloc(sizeof(char), 2);
+		ldap_mods[0]->mod_values[0] = ast_calloc(sizeof(char), strlen(newval) + 1);
+		strcpy(ldap_mods[0]->mod_values[0], newval);
+	}
+
 
 	while ((newparam = va_arg(ap, const char *))) {
 		newparam = convert_attribute_name_to_ldap(table_config, newparam);
@@ -1291,9 +1300,36 @@
 
 		for (i = 0; ldap_entry; i++) { 
 			dn = ldap_get_dn(ldapConn, ldap_entry);
-			if ((error = ldap_modify_ext_s(ldapConn, dn, ldap_mods, NULL, NULL)) != LDAP_SUCCESS) 
-				ast_log(LOG_ERROR, "Couldn't modify dn:%s because %s", dn, ldap_err2string(error));
 
+			int local_ldap_mods_size=1;
+			LDAPMod **local_ldap_mods = ast_calloc(sizeof(LDAPMod *), local_ldap_mods_size);
+			local_ldap_mods[0]=NULL;
+
+			for (i = 0; i < mods_size - 1; i++) {
+				int do_modify = 1;
+				if (ldap_mods[i]->mod_op==LDAP_MOD_DELETE){
+					struct berval ** existing_values =  ldap_get_values_len( ldapConn, ldap_entry, ldap_mods[i]->mod_type);
+					if (!existing_values ||  existing_values[0]==NULL) // No values 
+					        do_modify = 0;
+					
+					if (!existing_values) ldap_value_free_len(existing_values);
+				}
+				if (do_modify){
+				// copy mod from all mods to lcal mods
+					local_ldap_mods_size++;
+					local_ldap_mods = ast_realloc(local_ldap_mods, sizeof(LDAPMod *) * local_ldap_mods_size); 
+					local_ldap_mods[local_ldap_mods_size-1]=NULL;
+					local_ldap_mods[local_ldap_mods_size-2]=ldap_mods[i];
+				}
+			}
+			
+			
+			if ((error = ldap_modify_ext_s(ldapConn, dn, local_ldap_mods, NULL, NULL)) != LDAP_SUCCESS)
+				if (error==LDAP_REFERRAL){
+					ast_log(LOG_ERROR, "Referral link recieeved, not supported currently");
+				}else 
+					ast_log(LOG_ERROR, "Couldn't modify dn:%s because %s", dn, ldap_err2string(error));
+			ast_free(local_ldap_mods);
 			ldap_entry = ldap_next_entry(ldapConn, ldap_entry);
 		}
 	}
